---
title: Update team notification rule
description: Datadog, the leading service for cloud-scale monitoring.
breadcrumbs: Docs > API Reference > Teams
---

# Update team notification rule{% #update-team-notification-rule %}
Copy pageCopied
{% tab title="v2" %}

| Datadog site      | API endpoint                                                                         |
| ----------------- | ------------------------------------------------------------------------------------ |
| ap1.datadoghq.com | PUT https://api.ap1.datadoghq.com/api/v2/team/{team_id}/notification-rules/{rule_id} |
| ap2.datadoghq.com | PUT https://api.ap2.datadoghq.com/api/v2/team/{team_id}/notification-rules/{rule_id} |
| app.datadoghq.eu  | PUT https://api.datadoghq.eu/api/v2/team/{team_id}/notification-rules/{rule_id}      |
| app.ddog-gov.com  | PUT https://api.ddog-gov.com/api/v2/team/{team_id}/notification-rules/{rule_id}      |
| us2.ddog-gov.com  | PUT https://api.us2.ddog-gov.com/api/v2/team/{team_id}/notification-rules/{rule_id}  |
| app.datadoghq.com | PUT https://api.datadoghq.com/api/v2/team/{team_id}/notification-rules/{rule_id}     |
| us3.datadoghq.com | PUT https://api.us3.datadoghq.com/api/v2/team/{team_id}/notification-rules/{rule_id} |
| us5.datadoghq.com | PUT https://api.us5.datadoghq.com/api/v2/team/{team_id}/notification-rules/{rule_id} |

### Overview

This endpoint requires the `teams_read` permission.

OAuth apps require the `teams_read` authorization [scope](https://docs.datadoghq.com/api/latest/scopes.md#teams) to access this endpoint.



### Arguments

#### Path Parameters

| Name                      | Type   | Description |
| ------------------------- | ------ | ----------- |
| team_id [*required*] | string | None        |
| rule_id [*required*] | string | None        |

### Request

#### Body Data (required)



{% tab title="Model" %}

| Parent field | Field                        | Type    | Description                                                                |
| ------------ | ---------------------------- | ------- | -------------------------------------------------------------------------- |
|              | data [*required*]       | object  | Team notification rule                                                     |
| data         | attributes [*required*] | object  | Team notification rule attributes                                          |
| attributes   | email                        | object  | Email notification settings for the team                                   |
| email        | enabled                      | boolean | Flag indicating email notification                                         |
| attributes   | ms_teams                     | object  | MS Teams notification settings for the team                                |
| ms_teams     | connector_name               | string  | Handle for MS Teams                                                        |
| attributes   | pagerduty                    | object  | PagerDuty notification settings for the team                               |
| pagerduty    | service_name                 | string  | Service name for PagerDuty                                                 |
| attributes   | slack                        | object  | Slack notification settings for the team                                   |
| slack        | channel                      | string  | Channel for Slack notification                                             |
| slack        | workspace                    | string  | Workspace for Slack notification                                           |
| data         | id                           | string  | The identifier of the team notification rule                               |
| data         | type [*required*]       | enum    | Team notification rule type Allowed enum values: `team_notification_rules` |

{% /tab %}

{% tab title="Example" %}

```json
{
  "data": {
    "type": "team_notification_rules",
    "id": "b8626d7e-cedd-11eb-abf5-da7ad0900001",
    "attributes": {
      "pagerduty": {
        "service_name": "Datadog-prod"
      },
      "slack": {
        "workspace": "Datadog",
        "channel": "aaa-governance-ops"
      }
    }
  }
}
```

{% /tab %}

### Response

{% tab title="200" %}
OK
{% tab title="Model" %}
Team notification rule response

| Parent field | Field                        | Type    | Description                                                                |
| ------------ | ---------------------------- | ------- | -------------------------------------------------------------------------- |
|              | data                         | object  | Team notification rule                                                     |
| data         | attributes [*required*] | object  | Team notification rule attributes                                          |
| attributes   | email                        | object  | Email notification settings for the team                                   |
| email        | enabled                      | boolean | Flag indicating email notification                                         |
| attributes   | ms_teams                     | object  | MS Teams notification settings for the team                                |
| ms_teams     | connector_name               | string  | Handle for MS Teams                                                        |
| attributes   | pagerduty                    | object  | PagerDuty notification settings for the team                               |
| pagerduty    | service_name                 | string  | Service name for PagerDuty                                                 |
| attributes   | slack                        | object  | Slack notification settings for the team                                   |
| slack        | channel                      | string  | Channel for Slack notification                                             |
| slack        | workspace                    | string  | Workspace for Slack notification                                           |
| data         | id                           | string  | The identifier of the team notification rule                               |
| data         | type [*required*]       | enum    | Team notification rule type Allowed enum values: `team_notification_rules` |

{% /tab %}

{% tab title="Example" %}

```json
{
  "data": {
    "attributes": {
      "email": {
        "enabled": false
      },
      "ms_teams": {
        "connector_name": "string"
      },
      "pagerduty": {
        "service_name": "string"
      },
      "slack": {
        "channel": "string",
        "workspace": "string"
      }
    },
    "id": "b8626d7e-cedd-11eb-abf5-da7ad0900001",
    "type": "team_notification_rules"
  }
}
```

{% /tab %}

{% /tab %}

{% tab title="403" %}
Forbidden
{% tab title="Model" %}
API error response.

| Field                    | Type     | Description       |
| ------------------------ | -------- | ----------------- |
| errors [*required*] | [string] | A list of errors. |

{% /tab %}

{% tab title="Example" %}

```json
{
  "errors": [
    "Bad Request"
  ]
}
```

{% /tab %}

{% /tab %}

{% tab title="404" %}
API error response.
{% tab title="Model" %}
API error response.

| Field                    | Type     | Description       |
| ------------------------ | -------- | ----------------- |
| errors [*required*] | [string] | A list of errors. |

{% /tab %}

{% tab title="Example" %}

```json
{
  "errors": [
    "Bad Request"
  ]
}
```

{% /tab %}

{% /tab %}

{% tab title="429" %}
Too many requests
{% tab title="Model" %}
API error response.

| Field                    | Type     | Description       |
| ------------------------ | -------- | ----------------- |
| errors [*required*] | [string] | A list of errors. |

{% /tab %}

{% tab title="Example" %}

```json
{
  "errors": [
    "Bad Request"
  ]
}
```

{% /tab %}

{% /tab %}

### Code Example

##### 
                          \## default
# 
 \# Path parameters export team_id="CHANGE_ME" export rule_id="CHANGE_ME" \# Curl command curl -X PUT "https://api.datadoghq.com/api/v2/team/${team_id}/notification-rules/${rule_id}" \
-H "Accept: application/json" \
-H "Content-Type: application/json" \
-H "DD-API-KEY: ${DD_API_KEY}" \
-H "DD-APPLICATION-KEY: ${DD_APP_KEY}" \
-d @- << EOF
{
  "data": {
    "attributes": {
      "pagerduty": {
        "service_name": "Datadog-prod"
      },
      "slack": {
        "channel": "test-ops",
        "workspace": "Datadog"
      }
    },
    "id": "b8626d7e-cedd-11eb-abf5-da7ad0900001",
    "type": "team_notification_rules"
  }
}
EOF 
                        
##### 

```go
// Update team notification rule returns "OK" response

package main

import (
	"context"
	"encoding/json"
	"fmt"
	"os"

	"github.com/DataDog/datadog-api-client-go/v2/api/datadog"
	"github.com/DataDog/datadog-api-client-go/v2/api/datadogV2"
)

func main() {
	// there is a valid "dd_team" in the system
	DdTeamDataID := os.Getenv("DD_TEAM_DATA_ID")

	// there is a valid "team_notification_rule" in the system
	TeamNotificationRuleDataID := os.Getenv("TEAM_NOTIFICATION_RULE_DATA_ID")

	body := datadogV2.TeamNotificationRuleRequest{
		Data: datadogV2.TeamNotificationRule{
			Type: datadogV2.TEAMNOTIFICATIONRULETYPE_TEAM_NOTIFICATION_RULES,
			Id:   datadog.PtrString(TeamNotificationRuleDataID),
			Attributes: datadogV2.TeamNotificationRuleAttributes{
				Pagerduty: &datadogV2.TeamNotificationRuleAttributesPagerduty{
					ServiceName: datadog.PtrString("Datadog-prod"),
				},
				Slack: &datadogV2.TeamNotificationRuleAttributesSlack{
					Workspace: datadog.PtrString("Datadog"),
					Channel:   datadog.PtrString("aaa-governance-ops"),
				},
			},
		},
	}
	ctx := datadog.NewDefaultContext(context.Background())
	configuration := datadog.NewConfiguration()
	apiClient := datadog.NewAPIClient(configuration)
	api := datadogV2.NewTeamsApi(apiClient)
	resp, r, err := api.UpdateTeamNotificationRule(ctx, DdTeamDataID, TeamNotificationRuleDataID, body)

	if err != nil {
		fmt.Fprintf(os.Stderr, "Error when calling `TeamsApi.UpdateTeamNotificationRule`: %v\n", err)
		fmt.Fprintf(os.Stderr, "Full HTTP response: %v\n", r)
	}

	responseContent, _ := json.MarshalIndent(resp, "", "  ")
	fmt.Fprintf(os.Stdout, "Response from `TeamsApi.UpdateTeamNotificationRule`:\n%s\n", responseContent)
}
```

#### Instructions

First [install the library and its dependencies](https://docs.datadoghq.com/api/latest.md?code-lang=go) and then save the example to `main.go` and run following commands:
    DD_SITE="datadoghq.com" DD_API_KEY="<DD_API_KEY>" DD_APP_KEY="<DD_APP_KEY>" go run "main.go"
##### 

```java
// Update team notification rule returns "OK" response

import com.datadog.api.client.ApiClient;
import com.datadog.api.client.ApiException;
import com.datadog.api.client.v2.api.TeamsApi;
import com.datadog.api.client.v2.model.TeamNotificationRule;
import com.datadog.api.client.v2.model.TeamNotificationRuleAttributes;
import com.datadog.api.client.v2.model.TeamNotificationRuleAttributesPagerduty;
import com.datadog.api.client.v2.model.TeamNotificationRuleAttributesSlack;
import com.datadog.api.client.v2.model.TeamNotificationRuleRequest;
import com.datadog.api.client.v2.model.TeamNotificationRuleResponse;
import com.datadog.api.client.v2.model.TeamNotificationRuleType;

public class Example {
  public static void main(String[] args) {
    ApiClient defaultClient = ApiClient.getDefaultApiClient();
    TeamsApi apiInstance = new TeamsApi(defaultClient);

    // there is a valid "dd_team" in the system
    String DD_TEAM_DATA_ID = System.getenv("DD_TEAM_DATA_ID");

    // there is a valid "team_notification_rule" in the system
    String TEAM_NOTIFICATION_RULE_DATA_ID = System.getenv("TEAM_NOTIFICATION_RULE_DATA_ID");

    TeamNotificationRuleRequest body =
        new TeamNotificationRuleRequest()
            .data(
                new TeamNotificationRule()
                    .type(TeamNotificationRuleType.TEAM_NOTIFICATION_RULES)
                    .id(TEAM_NOTIFICATION_RULE_DATA_ID)
                    .attributes(
                        new TeamNotificationRuleAttributes()
                            .pagerduty(
                                new TeamNotificationRuleAttributesPagerduty()
                                    .serviceName("Datadog-prod"))
                            .slack(
                                new TeamNotificationRuleAttributesSlack()
                                    .workspace("Datadog")
                                    .channel("aaa-governance-ops"))));

    try {
      TeamNotificationRuleResponse result =
          apiInstance.updateTeamNotificationRule(
              DD_TEAM_DATA_ID, TEAM_NOTIFICATION_RULE_DATA_ID, body);
      System.out.println(result);
    } catch (ApiException e) {
      System.err.println("Exception when calling TeamsApi#updateTeamNotificationRule");
      System.err.println("Status code: " + e.getCode());
      System.err.println("Reason: " + e.getResponseBody());
      System.err.println("Response headers: " + e.getResponseHeaders());
      e.printStackTrace();
    }
  }
}
```

#### Instructions

First [install the library and its dependencies](https://docs.datadoghq.com/api/latest.md?code-lang=java) and then save the example to `Example.java` and run following commands:
    DD_SITE="datadoghq.com" DD_API_KEY="<DD_API_KEY>" DD_APP_KEY="<DD_APP_KEY>" java "Example.java"
##### 

```python
"""
Update team notification rule returns "OK" response
"""

from os import environ
from datadog_api_client import ApiClient, Configuration
from datadog_api_client.v2.api.teams_api import TeamsApi
from datadog_api_client.v2.model.team_notification_rule import TeamNotificationRule
from datadog_api_client.v2.model.team_notification_rule_attributes import TeamNotificationRuleAttributes
from datadog_api_client.v2.model.team_notification_rule_attributes_pagerduty import (
    TeamNotificationRuleAttributesPagerduty,
)
from datadog_api_client.v2.model.team_notification_rule_attributes_slack import TeamNotificationRuleAttributesSlack
from datadog_api_client.v2.model.team_notification_rule_request import TeamNotificationRuleRequest
from datadog_api_client.v2.model.team_notification_rule_type import TeamNotificationRuleType

# there is a valid "dd_team" in the system
DD_TEAM_DATA_ID = environ["DD_TEAM_DATA_ID"]

# there is a valid "team_notification_rule" in the system
TEAM_NOTIFICATION_RULE_DATA_ID = environ["TEAM_NOTIFICATION_RULE_DATA_ID"]

body = TeamNotificationRuleRequest(
    data=TeamNotificationRule(
        type=TeamNotificationRuleType.TEAM_NOTIFICATION_RULES,
        id=TEAM_NOTIFICATION_RULE_DATA_ID,
        attributes=TeamNotificationRuleAttributes(
            pagerduty=TeamNotificationRuleAttributesPagerduty(
                service_name="Datadog-prod",
            ),
            slack=TeamNotificationRuleAttributesSlack(
                workspace="Datadog",
                channel="aaa-governance-ops",
            ),
        ),
    ),
)

configuration = Configuration()
with ApiClient(configuration) as api_client:
    api_instance = TeamsApi(api_client)
    response = api_instance.update_team_notification_rule(
        team_id=DD_TEAM_DATA_ID, rule_id=TEAM_NOTIFICATION_RULE_DATA_ID, body=body
    )

    print(response)
```

#### Instructions

First [install the library and its dependencies](https://docs.datadoghq.com/api/latest.md?code-lang=python) and then save the example to `example.py` and run following commands:
    DD_SITE="datadoghq.com" DD_API_KEY="<DD_API_KEY>" DD_APP_KEY="<DD_APP_KEY>" python3 "example.py"
##### 

```ruby
# Update team notification rule returns "OK" response

require "datadog_api_client"
api_instance = DatadogAPIClient::V2::TeamsAPI.new

# there is a valid "dd_team" in the system
DD_TEAM_DATA_ID = ENV["DD_TEAM_DATA_ID"]

# there is a valid "team_notification_rule" in the system
TEAM_NOTIFICATION_RULE_DATA_ID = ENV["TEAM_NOTIFICATION_RULE_DATA_ID"]

body = DatadogAPIClient::V2::TeamNotificationRuleRequest.new({
  data: DatadogAPIClient::V2::TeamNotificationRule.new({
    type: DatadogAPIClient::V2::TeamNotificationRuleType::TEAM_NOTIFICATION_RULES,
    id: TEAM_NOTIFICATION_RULE_DATA_ID,
    attributes: DatadogAPIClient::V2::TeamNotificationRuleAttributes.new({
      pagerduty: DatadogAPIClient::V2::TeamNotificationRuleAttributesPagerduty.new({
        service_name: "Datadog-prod",
      }),
      slack: DatadogAPIClient::V2::TeamNotificationRuleAttributesSlack.new({
        workspace: "Datadog",
        channel: "aaa-governance-ops",
      }),
    }),
  }),
})
p api_instance.update_team_notification_rule(DD_TEAM_DATA_ID, TEAM_NOTIFICATION_RULE_DATA_ID, body)
```

#### Instructions

First [install the library and its dependencies](https://docs.datadoghq.com/api/latest.md?code-lang=ruby) and then save the example to `example.rb` and run following commands:
    DD_SITE="datadoghq.com" DD_API_KEY="<DD_API_KEY>" DD_APP_KEY="<DD_APP_KEY>" rb "example.rb"
##### 

```rust
// Update team notification rule returns "OK" response
use datadog_api_client::datadog;
use datadog_api_client::datadogV2::api_teams::TeamsAPI;
use datadog_api_client::datadogV2::model::TeamNotificationRule;
use datadog_api_client::datadogV2::model::TeamNotificationRuleAttributes;
use datadog_api_client::datadogV2::model::TeamNotificationRuleAttributesPagerduty;
use datadog_api_client::datadogV2::model::TeamNotificationRuleAttributesSlack;
use datadog_api_client::datadogV2::model::TeamNotificationRuleRequest;
use datadog_api_client::datadogV2::model::TeamNotificationRuleType;

#[tokio::main]
async fn main() {
    // there is a valid "dd_team" in the system
    let dd_team_data_id = std::env::var("DD_TEAM_DATA_ID").unwrap();

    // there is a valid "team_notification_rule" in the system
    let team_notification_rule_data_id = std::env::var("TEAM_NOTIFICATION_RULE_DATA_ID").unwrap();
    let body = TeamNotificationRuleRequest::new(
        TeamNotificationRule::new(
            TeamNotificationRuleAttributes::new()
                .pagerduty(
                    TeamNotificationRuleAttributesPagerduty::new()
                        .service_name("Datadog-prod".to_string()),
                )
                .slack(
                    TeamNotificationRuleAttributesSlack::new()
                        .channel("aaa-governance-ops".to_string())
                        .workspace("Datadog".to_string()),
                ),
            TeamNotificationRuleType::TEAM_NOTIFICATION_RULES,
        )
        .id(team_notification_rule_data_id.clone()),
    );
    let configuration = datadog::Configuration::new();
    let api = TeamsAPI::with_config(configuration);
    let resp = api
        .update_team_notification_rule(
            dd_team_data_id.clone(),
            team_notification_rule_data_id.clone(),
            body,
        )
        .await;
    if let Ok(value) = resp {
        println!("{:#?}", value);
    } else {
        println!("{:#?}", resp.unwrap_err());
    }
}
```

#### Instructions

First [install the library and its dependencies](https://docs.datadoghq.com/api/latest.md?code-lang=rust) and then save the example to `src/main.rs` and run following commands:
    DD_SITE="datadoghq.com" DD_API_KEY="<DD_API_KEY>" DD_APP_KEY="<DD_APP_KEY>" cargo run
##### 

```typescript
/**
 * Update team notification rule returns "OK" response
 */

import { client, v2 } from "@datadog/datadog-api-client";

const configuration = client.createConfiguration();
const apiInstance = new v2.TeamsApi(configuration);

// there is a valid "dd_team" in the system
const DD_TEAM_DATA_ID = process.env.DD_TEAM_DATA_ID as string;

// there is a valid "team_notification_rule" in the system
const TEAM_NOTIFICATION_RULE_DATA_ID = process.env
  .TEAM_NOTIFICATION_RULE_DATA_ID as string;

const params: v2.TeamsApiUpdateTeamNotificationRuleRequest = {
  body: {
    data: {
      type: "team_notification_rules",
      id: TEAM_NOTIFICATION_RULE_DATA_ID,
      attributes: {
        pagerduty: {
          serviceName: "Datadog-prod",
        },
        slack: {
          workspace: "Datadog",
          channel: "aaa-governance-ops",
        },
      },
    },
  },
  teamId: DD_TEAM_DATA_ID,
  ruleId: TEAM_NOTIFICATION_RULE_DATA_ID,
};

apiInstance
  .updateTeamNotificationRule(params)
  .then((data: v2.TeamNotificationRuleResponse) => {
    console.log(
      "API called successfully. Returned data: " + JSON.stringify(data)
    );
  })
  .catch((error: any) => console.error(error));
```

#### Instructions

First [install the library and its dependencies](https://docs.datadoghq.com/api/latest.md?code-lang=typescript) and then save the example to `example.ts` and run following commands:
    DD_SITE="datadoghq.com" DD_API_KEY="<DD_API_KEY>" DD_APP_KEY="<DD_APP_KEY>" tsc "example.ts"
{% /tab %}
